#!/usr/bin/python
# -*- coding: utf-8 -*-

import argparse
import glob
import os
import subprocess
import shutil


def __main__():
    parser = argparse.ArgumentParser()

    #files (single or pair)
    parser.add_argument('-f', type=str)
    parser.add_argument('-fwd', type=str)
    parser.add_argument('-rev', type=str)

    #oligos
    parser.add_argument('-oligo_len_1', type=int)
    parser.add_argument('-oligo_len_2', type=int)

    #options (allways there)
    parser.add_argument('-opt', type=str)

    #parser.add_argument('-k', action='store_true')

    options = parser.parse_args()

    # create the working dir
    os.mkdir('job_outputs')
    os.chdir('job_outputs')

    # create the populations command input line
    cmd_line=['clone_filter']
    if options.f is not None:
        cmd_line.extend(['-f', options.f])
    else:
        cmd_line.extend(['-1', options.fwd])
        cmd_line.extend(['-2', options.rev])

    if options.oligo_len_1 > -1:
        cmd_line.extend(['--oligo_len_1', options.oligo_len_1])
    if options.oligo_len_2 > -1:
        cmd_line.extend(['--oligo_len_2', options.oligo_len_2])
    cmd_line.append('--' + options.opt)

    print "[CMD]:"+' '.join(cmd_line)
    subprocess.call(cmd_line)

    # postprocesses
    clean_files = glob.glob('*.fq*')
    if options.f is not None:
        shutil.copy(clean_files[0], 'clean.fq')
    else:
        shutil.copy(clean_files[0], 'fwd.fq')
        shutil.copy(clean_files[1], 'rev.fq')


if __name__ == '__main__':
    __main__()
